'vttowav by df6nm 
'20-09-01

'compiled with FreeBasic: fbc -e vttowav.bas
'usage: vttowav file.vt [freq]
'or drag and drop file.vt over program icon

'$ lang: "qb"
deflng a-z

cf!=0
cmd$ = ltrim$(rtrim$(command$))
file$=cmd$
if instr(cmd$," ")>0 then 
 file$=left$(cmd$,instr(cmd$," ")-1)
 cf!=val(right$(cmd$,len(cmd$)-instr(cmd$," ")))
end if

wavfile$=file$
if instr(wavfile$,".")>0 then wavfile$=left$(wavfile$,instr(wavfile$,".")-1)
wavfile$=wavfile$+".wav"

? file$;", freq";cf!;" Hz,";

out$=""
n=0
open file$ for input as 1
while not eof(1)
 input #1, ts#,ar!,ai!
 if n=0 then ts0#=ts#
 out$=out$+mks$(ar!)+mks$(ai!)
 n=n+1
wend
close 1
nmx=n
sr!=(nmx-1)/(ts#-ts0#)

? nmx;"samples, sr";sr!;" Hz, starttime";ts0#

GOSUB wavheader
open wavfile$ for output as 2
? #2, hdr$;out$;
close 2

end

'_______________________________________
wavheader:

 inf1$="sr="+ltrim$(str$(sr!))+" "
 inf1$=inf1$+"rf="+ltrim$(str$(cf!))+" "
 inf1$=inf1$+"ut=" + ltrim$(str$(ts0#))
 inf1$=inf1$+mkl$(0)
 inf1$=left$(inf1$,4*int((len(inf1$)-1)\4)) 
 inf1$="inf1"+mkl$(len(inf1$))+inf1$
 
 fmt$=mki$(-2)+mki$(2)+mkl$(sr!)+mkl$(int(sr!+.5)*8)
 fmt$=fmt$+mki$(8)+mki$(32)+mki$(22)+mki$(32)+mkl$(0)+mkl$(3)
 fmt$=fmt$+mki$(0)+mki$(16)+mki$(128)+mki$(-22016)+mki$(14336)+mki$(29083)
 fmt$="fmt "+mkl$(len(fmt$))+fmt$

 fact$="fact"+mkl$(4)+mkl$(nmx)

 hdr$="WAVE"+fmt$+fact$+inf1$+"data"+mkl$(8*nmx)
 hdr$="RIFF"+mkl$(len(hdr$)+8*nmx)+hdr$  
return
